require(['config'], function() {
	require([
		'kakao.postcode',
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 * let sfflyObj = {}		: 공급업체담당자 Object		*
 *******************************************************/

/*화면 변수*/
const STINFO03010_GRID_ID = '#ITP_STINFO03010_jqGrid';
const STINFO03010_GRID_LIST = '#ITP_STINFO03010_jqGrid_list';
const STINFO03010_GRID_PAGER = '#ITP_STINFO03010_jqGridPager';
const STINFO03010_GRID_EMPTY = '#ITP_STINFO03010_jqGridEmpty';

const STINFO03010_VIEW_GRID_ID = '#ITP_STINFO03010_VIEW_jqGrid';
const STINFO03010_VIEW_GRID_LIST = '#ITP_STINFO03010_VIEW_jqGrid_list';
const STINFO03010_VIEW_GRID_PAGER = '#ITP_STINFO03010_VIEW_jqGridPager';
const STINFO03010_VIEW_GRID_EMPTY = '#ITP_STINFO03010_VIEW_jqGridEmpty';

const STINFO03010_DETAIL_GRID_ID = '#ITP_STINFO03010_DETAIL_jqGrid';
const STINFO03010_DETAIL_GRID_LIST = '#ITP_STINFO03010_DETAIL_jqGrid_list';
const STINFO03010_DETAIL_GRID_PAGER = '#ITP_STINFO03010_DETAIL_jqGridPager';
const STINFO03010_DETAIL_GRID_EMPTY = '#ITP_STINFO03010_DETAIL_jqGridEmpty';

let ITP_FORM_STINFO03010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_STINFO03010_DETAIL_IS_WRITING = false;

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/spply/detail-grid-list';	// 목록
let API_DETAIL_INFO 		= '/api/spply/info-spply';			// 상세
let API_DETAIL_SAVE 		= '/api/spply/save-spply';			// 저장
let API_INTI_PW				= '/api/spply/inti-spplyPw';		// 패스워드 초기화
let API_POP_GRID_LIST 		= '/api/spply/pop-grid-list';		// 공급사 팝업 그리드 리스트

/*화면 Grid ColModel*/
const gridColModel = {
	list: [
		{
			index: 'SFFLY_ID', name: 'spplyId',
			label: ITP_MSG_LOCALE.label.spplyId
			, //공급업체번호
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'SFFLY_NM', name: 'spplyNm',
			label: ITP_MSG_LOCALE.label.spplyNm, //공급업체명
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'BRAND_ID', name: 'brandId',
			label: ITP_MSG_LOCALE.label.brandId, //브랜드ID
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.label.brandNm, //브랜드명
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'BSNS_REG_NO', name: 'bsnsRegNo',
			label: ITP_MSG_LOCALE.label.bsnsRegNo, //사업자등록번호
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'OWNER_NM', name: 'ownerNm',
			label: ITP_MSG_LOCALE.label.ownerNm, //대표자명
			width: '15', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'ST_NM', name: 'stNm',
			label: ITP_MSG_LOCALE.label.stNm, //상태
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'SYS_REG_DTTM', name: 'sysRegDttm',
			label: ITP_MSG_LOCALE.label.sysRegDttm, //최초등록일
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
	],
	detail: [
		{
			index: 'VIEW_CD', name: 'viewCd',
			label: ITP_MSG_LOCALE.label.viewCd,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'SPPLY_ID', name: 'spplyId',
			label: ITP_MSG_LOCALE.label.spplyId,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'SPPLY_MGR_ID', name: 'spplyMgrId',
			label: ITP_MSG_LOCALE.label.spplyMgrId,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'ASSGN_TASK_NM', name: 'spplyMgrNm',
			label: ITP_MSG_LOCALE.label.spplyMgrNm, //담당자명
			width: '20', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text',
			editrules: {required: true}
		},
		{
			index: 'POSITION', name: 'position',
			label: ITP_MSG_LOCALE.label.position, //직위
			width: '30', fixed: false, align: 'center',
			sortable: true, editable: true, edittype: 'text',
			editrules: {required: true}
		},
		{
			index: 'RPRST_EMAIL', name: 'rprstEmal',
			label: ITP_MSG_LOCALE.label.rprstEmal, //이메일
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text'
		},
		{
			index: 'RPRST_TEL_NO', name: 'rprstTelNo',
			label: ITP_MSG_LOCALE.label.rprstMblNo, //핸드폰번호
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text'
		},
		{
			index: 'ASSGN_TASK_NM', name: 'assgnTaskNm',
			label: ITP_MSG_LOCALE.label.assgnTaskNm, //담당업무
			width: '10', fixed: false, align: 'center',
			sortable: false, editable: true, edittype: 'text'
		}
	]
};

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.brandInfo = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
		this.ui.init();
		this.event.init();
	},
	brandInfo: {},
	ui: {
		init: function () {
			this.view();
			this.grid();
			this.ready();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('STINFO03010');

			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});
		},
		grid: function() {
			itp_fn_jqgrid_resize(STINFO03010_GRID_ID, STINFO03010_GRID_LIST, 'lg');
			listObj.empty.init();
			itp_fn_fire_window_resize();
		},
		ready: function() {
			listObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_STINFO03010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_STINFO03010_NEWREG'			: listObj.button.create(); 		break;	// 신규등록 버튼
						case 'ITP_BTN_STINFO03010_MODIFY'			: modifyObj.button.modify();	break;	// 수정 버튼
						case 'ITP_BTN_STINFO03010_CANCELLIST'		: createObj.button.cancel(); 	break;	// 취소/목록 버튼
						case 'ITP_BTN_STINFO03010_DELETE'			: 								break;	// 삭제 버튼
						case 'ITP_BTN_STINFO03010_SAVE'				: createObj.button.save(); 		break;	// 저장 버튼
						case 'ITP_FORM_STINFO03010_DETAIL_DUP'		: createObj.button.duplicate();	break;	// 중복체크
						case 'ITP_BTN_STINFO03010_RESET_PW'			: createObj.button.resetPass();	break;	// 상세:비밀번호 초기화
						case 'ITP_BTN_STINFO03010_DETAIL_ADDROW'	: createObj.button.addRow();	break;	// 행추가
						case 'ITP_BTN_STINFO03010_DETAIL_DELROW'	: createObj.button.delRow();	break;	// 행삭제
					}
				});
			});

			$('body').on('click', function(e) {
				var gridId = STINFO03010_DETAIL_GRID_ID.replace('#', '');
				var rids = $(STINFO03010_DETAIL_GRID_ID).jqGrid('getDataIDs');
				var last_row_id = rids[rids.length - 1];
				itp_fn_grid_reset_selection(e, last_row_id, gridId, 'STINFO03010_DETAIL');
			});

		}
	},
	switchScreen: function(mode) {
		if(mode == 'LIST') { // 목록
			$('#ITP_BTN_STINFO03010_MODIFY').hide();
			$('#ITP_BTN_STINFO03010_CANCELLIST').hide();
			$('#ITP_BTN_STINFO03010_DELETE').hide();
			$('#ITP_BTN_STINFO03010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO03010_SRH');
			fn_show_btn_auth('#ITP_BTN_STINFO03010_NEWREG');

			$('#ITP_AJAX_STINFO03010_LIST_CONTAINER').show();
			$('#ITP_AJAX_STINFO03010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO03010_VIEW_CONTAINER').hide();
		} else if(mode == 'ADD') { // 등록
			$('#ITP_BTN_STINFO03010_SRH').hide();
			$('#ITP_BTN_STINFO03010_MODIFY').hide();
			$('#ITP_BTN_STINFO03010_NEWREG').hide();
			$('#ITP_BTN_STINFO03010_DELETE').hide();
			$('#ITP_BTN_STINFO03010_RESET_PW').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO03010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO03010_SAVE');

			$('#ITP_AJAX_STINFO03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO03010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO03010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_STINFO03010_DETAIL_STORE_ID').removeAttr('readonly');
			$('#ITP_FORM_STINFO03010_DETAIL_DUP').removeAttr('disabled');

			$.each($('input, select, checkbox, radio, textarea', '#ITP_FORM_STINFO03010_DETAIL'),function(k) {
				$(this).val('');
			});

			$('#ITP_FORM_STINFO03010_DETAIL_VIEW_CD').val('C');
			$('#ITP_FORM_STINFO03010_DETAIL .fnSpplyId').text('(자동부여) (비밀번호는 사업자번호로 초기화 됩니다.)');
		} else if(mode == 'MODIFY') { // 수정
			$('#ITP_BTN_STINFO03010_SRH').hide();
			$('#ITP_BTN_STINFO03010_MODIFY').hide();
			$('#ITP_BTN_STINFO03010_NEWREG').hide();
			$('#ITP_BTN_STINFO03010_DELETE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO03010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO03010_SAVE');
			fn_show_btn_auth('#ITP_BTN_STINFO03010_RESET_PW');

			$('#ITP_AJAX_STINFO03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO03010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO03010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_STINFO03010_DETAIL_STORE_ID').attr('readonly', true);
			$('#ITP_FORM_STINFO03010_DETAIL_DUP').attr('disabled', true);
			$('#ITP_FORM_STINFO03010_DETAIL_SEARCH_AFFL_SHOP_NM').attr('readonly', true);

			$('#ITP_FORM_STINFO03010_DETAIL_SEARCH_AFFL_SHOP').hide();
			$('#ITP_FORM_STINFO03010_DETAIL_DELETE_AFFL_SHOP').hide();
		} else if(mode == 'VIEW') { // 보기
			$('#ITP_BTN_STINFO03010_SRH').hide();
			$('#ITP_BTN_STINFO03010_NEWREG').hide();
			$('#ITP_BTN_STINFO03010_DELETE').hide();
			$('#ITP_BTN_STINFO03010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO03010_MODIFY');
			fn_show_btn_auth('#ITP_BTN_STINFO03010_CANCELLIST');

			$('#ITP_AJAX_STINFO03010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO03010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO03010_VIEW_CONTAINER').show();
		}
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
		this.grid.init();
	},
	itp_STINFO03010_search: false,
	button: {
		search: function() {
			listObj.itp_STINFO03010_search = true;
			let param = $('#ITP_FORM_STINFO03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(STINFO03010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		},
		create: function() {
			if(pageObj.brandInfo && pageObj.brandInfo.brandId !== '') {
				createObj.init();
			}
		}
	},
	empty: {
		init: function() {
			var _this = this;
			this.push();
			$(STINFO03010_GRID_EMPTY).on('click', function() {
				_this.back();
				_this.itp_STINFO03010_param.gridSize = $.jgrid.defaults.rowNum;
				$(STINFO03010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STINFO03010_param)}).trigger('reloadGrid');
			});
		},
		itp_STINFO03010_param: {},
		push: function() {
			let param = $('#ITP_FORM_STINFO03010_SEARCH').serializeObject();
			listObj.itp_STINFO03010_param = param;
		},
		back: function() {
			$('#ITP_FORM_STINFO03010_SERVICE_ST_DT').val(this.itp_STINFO03010_param.serviceStDt);
			$('#ITP_FORM_STINFO03010_SEARCH_BSNS_REG_NO').val(this.itp_STINFO03010_param.sbsnsRegNo);
			$('#ITP_FORM_STINFO03010_SEARCH_SPPLY_NM').val(this.itp_STINFO03010_param.sspplyNm);
		}
	},
	grid: {
		init: function () {
			// 데이터 없을때
			listObj.empty.push();
			this.search();
		},
		colModel: gridColModel.list,
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			let param = $('#ITP_FORM_STINFO03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.sbrandId = pageObj.brandInfo.brandId;

			var option = {
				gridId: STINFO03010_GRID_ID,
				colModel: gridColModel.list,
				param: JSON.stringify(param),
				url: DOMAIN + API_DETAIL_GRID_LIST,
				pager: STINFO03010_GRID_PAGER,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'spplyNm') {
						const selectVal = $(this).jqGrid('getCell', rowId, 'spplyId');
						const key = {brandId:pageObj.brandInfo.brandId, spplyId: selectVal, viewCd: 'R'};
						var param = $.param(key);
						viewObj.init(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, STINFO03010_GRID_ID, true, 'number', 'STINFO03010', listObj.itp_STINFO03010_search, listObj.empty, true, data.gridRecords, true);
					var ids = $(STINFO03010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(STINFO03010_GRID_ID).jqGrid('setCell', rowId, 'spplyNm', '', ITP_GRID_COL_STYLE.link);
					});
				},
				onPaging: function(action) {
					itp_fn_grid_paging(STINFO03010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(STINFO03010_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO03010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO03010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO03010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO03010_GRID_ID);
		}
	}
};

/*상세화면 Object*/
let viewObj = {
	init: function (param) {
		this.load(param);
	},
	load: function(param) {
		fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
	},
	callback: function (result) {
		console.log(result);
		pageObj.switchScreen('VIEW');
		$('#ITP_FORM_STINFO03010_VIEW #ITP_FORM_STINFO03010_DETAIL_SPPLY_ID').val(result.spplyId);
		$('#ITP_FORM_STINFO03010_VIEW .fnBrandNm').text(result.brandNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnStCd').text(result.stNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnSpplyId').text(result.spplyId);
		$('#ITP_FORM_STINFO03010_VIEW .fnCorpType').text(result.corpTypeNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnSpplyNm').text(result.spplyNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnBsnsCndt').text(result.bsnsCndt);
		$('#ITP_FORM_STINFO03010_VIEW .fnBsnsRegNo').text(result.bsnsRegNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnCtgrBsns').text(result.ctgrBsns);
		$('#ITP_FORM_STINFO03010_VIEW .fnCorpRegNo').text(result.corpRegNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnTelNo').text(result.mgrTelNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnOwnerNm').text(result.ownerNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnFaxNo').text(result.faxNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnMblNo').text(result.mgrMblNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnEmalAddr').text(result.mgrEmal);
		$('#ITP_FORM_STINFO03010_VIEW .fnAreaCd').text(result.areaNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnBnkCd').text(result.bnkNm);
		$('#ITP_FORM_STINFO03010_VIEW .fnAcctNo').text(result.acctNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnOwacNm').text(result.owacNm);
		// 통장사본 fileBookCopyNoList
		//$('#ITP_FORM_STINFO03010_VIEW .fnFilePath').text(result.fileBookCopyNoList);
		// 사업자등록파일 fileBsnsRegNoList
		//$('#ITP_FORM_STINFO03010_VIEW .fnFilePath').text(result.fileBsnsRegNoList);
		$('#ITP_FORM_STINFO03010_VIEW .fnZipNo').text(result.zipNo);
		$('#ITP_FORM_STINFO03010_VIEW .fnLoadAddr').text(result.addr1);
		$('#ITP_FORM_STINFO03010_VIEW .fnDtlAddr').text(result.addr2);
		// $('#ITP_FORM_STINFO03010_VIEW .fnRegDt').text(result.openDt);
		// $('#ITP_FORM_STINFO03010_VIEW .fnCloseDt').text(result.openDt);

		// 담당자정보  리스트 조회
		viewObj.grid.load(result.spplyMgrList);
	},
	grid: {
		init: function() {
		},
		load: function(gridList) {
			var option = {
				gridId: STINFO03010_VIEW_GRID_ID,
				colModel: gridColModel.detail,
				data: gridList,
				pager: STINFO03010_VIEW_GRID_PAGER,
			};
			itp_fn_grid_make_local(option);
		},
		clearData : function() {
			$(STINFO03010_VIEW_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO03010_VIEW_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO03010_VIEW_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO03010_VIEW_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO03010_VIEW_GRID_ID);
		}
	}
};

/*수정화면 Object*/
let modifyObj = {
	init: function () {
	},
	button: {
		modify: function (param) {
			itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO03010_DETAIL');
			const selectVal = $('#ITP_FORM_STINFO03010_DETAIL_SPPLY_ID').val();
			const key = {brandId:pageObj.brandInfo.brandId, spplyId: selectVal, viewCd: 'R'};
			var param = $.param(key);
			modifyObj.load(param);
		}
	},
	load: function(param) {
		fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
	},
	callback: function (result) {
		console.log(result);
		pageObj.switchScreen('MODIFY');

		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_VIEW_CD').val('U');
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_STORE_ID').val(result.storeId);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_BRAND_ID').val(pageObj.brandInfo.brandId);
		$('#ITP_FORM_STINFO03010_DETAIL .fnBrandNm').text(result.brandNm);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_ST_CD').val(result.stCd);
		$('#ITP_FORM_STINFO03010_DETAIL .fnSpplyId').text(result.spplyId);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_CORP_TYPE').val(result.corpType);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_SPPLY_NM').val(result.spplyNm);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_BSNS_CNDT').val(result.bsnsCndt);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_BSNS_REG_NO').val(result.bsnsRegNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_CTGR_BSNS').val(result.ctgrBsns);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_CORP_REG_NO').val(result.corpRegNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_TEL_NO').val(result.mgrTelNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_OWNER_NM').val(result.ownerNm);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_FAX_NO').val(result.faxNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_MBL_NO').val(result.mgrMblNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_EMAL_ADDR').val(result.mgrEmal);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_AREA_CD').val(result.areaCd);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_BNK_CD').val(result.bnkCd);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_ACCT_NO').val(result.acctNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_OWAC_NM').val(result.owacNm);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_FROM_DT').val(result.openDt);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_ZIP_NO').val(result.zipNo);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_LOAD_ADDR').val(result.addr1);
		$('#ITP_FORM_STINFO03010_DETAIL #ITP_FORM_STINFO03010_DETAIL_DTL_ADDR').val(result.addr2);

		// 담당자정보  리스트 조회
		modifyObj.grid.load(result.spplyMgrList);
	},
	grid: {
		init: function() {
		},
		load: function(gridList) {
			var option = {
				gridId: STINFO03010_DETAIL_GRID_ID,
				colModel: gridColModel.detail,
				data: gridList,
				pager: STINFO03010_DETAIL_GRID_PAGER,
			};
			itp_fn_grid_make_local(option);
		},
		clearData : function() {
			$(STINFO03010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO03010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO03010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO03010_DETAIL_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO03010_DETAIL_GRID_ID);
		}
	}
};

/*신규화면 Object*/
let createObj = {
	init: function () {
		pageObj.switchScreen('ADD');
		itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO03010_DETAIL');
		$('#ITP_FORM_STINFO03010_DETAIL_BRAND_ID').val(pageObj.brandInfo.brandId);
		this.unload();
		this.load();
	},
	button: {
		cancel: function() {
			listObj.grid.search();
		},
		addRow: function() {
			itp_fn_grid_add_row(STINFO03010_DETAIL_GRID_ID, undefined, ['spplyId'], 'STINFO03010_DETAIL');
		},
		delRow: function() {
			itp_fn_grid_del_row(STINFO03010_DETAIL_GRID_ID);
		},
		save: function() {
			const formId = '#ITP_FORM_STINFO03010_DETAIL';
			itp_fn_form_clear_validate(null, formId);
			var vali_userId = itp_fn_form_validate(formId, formId + '_USER_ID', ['empty'], undefined);
			var vali_userStatCd = itp_fn_form_validate(formId, formId + '_USER_STAT_CD', ['empty'], undefined);
			var vali_userNm = itp_fn_form_validate(formId, formId + '_USER_NM', ['empty'], undefined);
			var vali_telNo = itp_fn_form_validate(formId, formId + '_TEL_NO', ['empty'], undefined);
			var vali_email = itp_fn_form_validate(formId, formId + '_EMAIL', ['empty'], undefined);
			var vali_userPw = true;
			var vali_userPwConfirm = true;
			if (vali_userId && vali_userStatCd && vali_userNm && vali_userPw && vali_userPwConfirm && vali_telNo && vali_email) {
				if (ITP_FORM_STINFO03010_DETAIL_IS_DUPLICATE) {
					itp_fn_modal_duplicate(ITP_MSG_LOCALE.label.userId, formId + '_USER_ID');
				} else {
					let gridInsertData = [];
					let gridUpdateData = [];
					let gridDeleteData = [];
					const rowData = $(STINFO03010_DETAIL_GRID_ID).getRowData();
					const keyValue = $(formId + '_USER_ID').val();
					$.each(rowData, function(key, value) {
						if (value.viewCd != 'R') {
							value.userId = keyValue;
							if (value.viewCd == 'C') {
								gridInsertData.push(value);
							} else if (value.viewCd == 'U') {
								gridUpdateData.push(value);
							} else if (value.viewCd == 'D') {
								gridDeleteData.push(value);
							}
						}
					});
					let param = $(formId).serializeObject();
					param.gridInsertData = gridInsertData;
					param.gridUpdateData = gridUpdateData;
					param.gridDeleteData = gridDeleteData;
					//console.log(JSON.stringify(param));
					var searhFn = function() {
						ITP_FORM_STINFO03010_DETAIL_IS_WRITING = false;
						listObj.grid.search();
					};
					fn_ajax_call(API_DETAIL_SAVE, JSON.stringify(param), searhFn, 'POST');
				}
			}
		},
		resetPass: function() {
			var resetPwFn = {
				callBack: function(args) {
					const key = {'storeId':  $('#ITP_FORM_STINFO03010_DETAIL_STORE_ID').val()};
					const param = $.param(key);
					fn_ajax_call(API_INTI_PW, param, undefined, 'GET');
				}
			};
			itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.askResetUserPw, resetPwFn, null);
		}
	},
	load: function () {
		var option = {
			gridId: STINFO03010_DETAIL_GRID_ID,
			colModel: gridColModel.detail,
			data: [],
			pager: STINFO03010_DETAIL_GRID_PAGER,
		};
		itp_fn_grid_make_local(option);
	},
	clearData : function() {
		$(STINFO03010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
		$(STINFO03010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(STINFO03010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(STINFO03010_DETAIL_GRID_EMPTY).show();
	},
	unload : function() {
		$.jgrid.gridUnload(STINFO03010_DETAIL_GRID_ID);
	}
};
