require(['config'], function() {
	require([
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

const OPER02010_GRID_ID = '#ITP_OPER02010_jqGrid';
const OPER02010_GRID_LIST = '#ITP_OPER02010_jqGrid_list';
const OPER02010_GRID_PAGER = '#ITP_OPER02010_jqGridPager';
const OPER02010_GRID_EMPTY = '#ITP_OPER02010_jqGridEmpty';

const OPER02010_VIEW_GRID_ID = '#ITP_OPER02010_VIEW_jqGrid';
const OPER02010_VIEW_GRID_LIST = '#ITP_OPER02010_VIEW_jqGrid_list';
const OPER02010_VIEW_GRID_PAGER = '#ITP_OPER02010_VIEW_jqGridPager';
const OPER02010_VIEW_GRID_EMPTY = '#ITP_OPER02010_VIEW_jqGridEmpty';

const OPER02010_DETAIL_GRID_ID = '#ITP_OPER02010_DETAIL_jqGrid';
const OPER02010_DETAIL_GRID_LIST = '#ITP_OPER02010_DETAIL_jqGrid_list';
const OPER02010_DETAIL_GRID_PAGER = '#ITP_OPER02010_DETAIL_jqGridPager';
const OPER02010_DETAIL_GRID_EMPTY = '#ITP_OPER02010_DETAIL_jqGridEmpty';

let ITP_FORM_OPER02010_DETAIL_IS_WRITING = false;

let NTICE_SAVE_NTICE = '/api/ntice/save-ntice';
let NTICE_DETAIL_GRID_LIST = '/api/ntice/detail-grid-list';
let NTICE_INFO_NTICE = '/api/ntice/info-ntice';
let NTICE_TARGET_GRID_LIST = '/api/ntice/target-grid-list';

// Grid Column Model
const gridColModel = {
	// 목록
	list: [
		{
			index: 'NTICE_NO', name: 'nticeNo',
			label: ITP_MSG_LOCALE.label.notiNo, //공지번호
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'AFFL_SHOP_NM', name: 'afflShopNm',
			label: ITP_MSG_LOCALE.label.afflShopNm, //가맹점
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.label.brandNm, //브랜드
			width: '13', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'NTICE_TITL', name: 'nticeTitl',
			label: ITP_MSG_LOCALE.label.titlet, //공지제목
			width: '15', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'TARGET_NM', name: 'targetNm',
			label: ITP_MSG_LOCALE.label.targetNm, //공지대상
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'NTICE_STAT_NM', name: 'nticeStatNm',
			label: ITP_MSG_LOCALE.label.status, //상태
			width: '6', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'NOTI_ST_DAY', name: 'notiStDay',
			label: ITP_MSG_LOCALE.label.viewDt, //노출일
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		},
		{
			index: 'ADD_DT', name: 'addDt',
			label: ITP_MSG_LOCALE.label.regDt, //등록일
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: false
		}
	],
	detail: [
		{
			index: 'VIEW_CD', name: 'viewCd',
			label: ITP_MSG_LOCALE.label.viewCd,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'NTICE_NO', name: 'nticeNo',
			label: ITP_MSG_LOCALE.label.notiNo,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'BRAND_ID', name: 'brandId',
			label: ITP_MSG_LOCALE.label.brandId,
			width: '20', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text'
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.label.brandNm,
			width: '30', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text'
		}
	],
	brand: [
		{
			index: 'VIEW_CD', name: 'viewCd',
			label: ITP_MSG_LOCALE.label.viewCd,
			width: '10', fixed: false, align: 'center',
			sortable: false, hidden: true
		},
		{
			index: 'BRAND_ID', name: 'brandId',
			label: ITP_MSG_LOCALE.table.brandId,
			width: '20', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text'
		},
		{
			index: 'BRAND_NM', name: 'brandNm',
			label: ITP_MSG_LOCALE.table.brandNm,
			width: '30', fixed: false, align: 'center',
			sortable: false, editable: false, edittype: 'text'
		}
	]
};

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
	},
	ui: {
		init: function () {
			this.button();
			this.ready();
		},
		button: function () {
			// 버튼 권한설정
			fn_proc_btn_auth('OPER02010');

			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});

			// 조회일자 지정
			var now = new Date();
			$('#ITP_TAB_OPER02010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);
			$('#ITP_FORM_OPER02010_SEARCH_FROM_DT').datepicker('setDate', new Date(now.setMonth(now.getMonth() - 1)));
			$('#ITP_FORM_OPER02010_SEARCH_TO_DT').datepicker('setDate', new Date());
		},
		ready: function () {
			listObj.init();
			// 가맹점 조회
			afflShopObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_OPER02010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_OPER02010_NEWREG'				: listObj.button.create(); 		break;	// 신규등록 버튼
						case 'ITP_BTN_OPER02010_MODIFY'				: modifyObj.button.modify();	break;	// 수정 버튼
						case 'ITP_BTN_OPER02010_CANCELLIST'			: createObj.button.cancel(); 	break;	// 취소/목록 버튼
						case 'ITP_BTN_OPER00210_DELETE'				: 								break;	// 삭제 버튼
						case 'ITP_BTN_OPER02010_SAVE'				: createObj.button.save(); 		break;	// 저장 버튼
						case 'ITP_BTN_OPER02010_DETAIL_ADDROW'		: createObj.button.addRow();	break;	// 상세:추가버튼
						case 'ITP_BTN_OPER02010_DETAIL_DELROW'		: createObj.button.delRow();	break;	// 상세:삭제버튼
					}
				});
			});

		}
	},
	switchScreen: function(mode) {
		$('.itp_det_head').find('button[id^="ITP_BTN_OPER02010_"]').each(function(i) {
			$(this).hide();
		});
		$('div[id$="_CONTAINER"]').each(function(i) {
			if($(this).attr('id').startsWith('ITP_AJAX_OPER02010')) {
				$(this).hide();
			}
		});
		if(mode === 'LIST') { // 목록
			fn_show_btn_auth_array(['#ITP_BTN_OPER02010_SRH', '#ITP_BTN_OPER02010_NEWREG']);
			$('#ITP_AJAX_OPER02010_LIST_CONTAINER').show();
		} else if(mode == 'ADD') { // 등록
			fn_show_btn_auth_array(['#ITP_BTN_OPER02010_CANCELLIST', '#ITP_BTN_OPER02010_SAVE']);
			$('#ITP_AJAX_OPER02010_DETAIL_CONTAINER').show();

			$('input[id^="ITP_FORM_OPER02010_DETAIL_"]').each(function(i) {
				($(this).attr('id') === 'ITP_FORM_OPER02010_DETAIL_VIEW_CD') ? $(this).val('C') : $(this).val('');
			});

			$('#ITP_FORM_OPER02010_FROM_DT').datepicker('setDate', new Date());
			$('#ITP_FORM_OPER02010_TO_DT').datepicker('setDate', new Date());

			$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_AFFL_SHOP_ID').val('');
			$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_AFFL_SHOP_NM').val('').prop('readonly', true);
			$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SEARCH_BRAND_ID option').remove();
		} else if(mode === 'MODIFY') { // 수정
			fn_show_btn_auth_array(['#ITP_BTN_OPER02010_CANCELLIST', '#ITP_BTN_OPER02010_SAVE', '#ITP_BTN_OPER02010_RESET_PW']);
			$('#ITP_AJAX_OPER02010_DETAIL_CONTAINER').show();
			$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_AFFL_SHOP_NM').prop('readonly', true);
		} else if(mode === 'VIEW') { // 보기
			fn_show_btn_auth_array(['#ITP_BTN_OPER02010_MODIFY', '#ITP_BTN_OPER02010_CANCELLIST']);
			$('#ITP_AJAX_OPER02010_VIEW_CONTAINER').show();
		}
	},
	grid: {
		init: function(mode) {
			this.gridId = (mode === 'VIEW') ? OPER02010_VIEW_GRID_ID : OPER02010_DETAIL_GRID_ID;
			this.unload();
			this.load(mode);
		},
		gridId: '',
		load : function(mode) {
			let param = $('#ITP_FORM_OPER02010_' + mode).serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.pagingYn = false; // 페이지안함

			var _gridId = this.gridId;
			var option = {
				gridId: _gridId,
				colModel: gridColModel.detail,
				param: JSON.stringify(param),
				url: DOMAIN + NTICE_TARGET_GRID_LIST,
				multiselect: (mode !== 'VIEW'),
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, _gridId, true, undefined, 'OPER02010_' + mode);
				},
				onSortCol: function(index, columnIndex, sortOrder) {
					var sortingFn = {
						callBack: function(args) {
							$(args).trigger('reloadGrid');
						}
					};
					if (itp_fn_check_grid_is_writing(_gridId)) {
						itp_fn_modal_confirm(ITP_MSG_LOCALE.message.ajax.cancelData, sortingFn, _gridId);
						return 'stop';
					} else {
						itp_fn_grid_sorting(_gridId, index, sortOrder);
					}
				}
			};
			itp_fn_grid_make_not_paging(option);
		},
		resetGrid: function(e) {
			var gridId = this.gridId.replace('#', '');
			var rids = $(this.gridId).jqGrid('getDataIDs');
			var last_row_id = rids[rids.length - 1];
			itp_fn_grid_reset_selection(e, last_row_id, gridId, 'OPER02010_' + mode);
		},
		unload : function() {
			$.jgrid.gridUnload(this.gridId);
		}
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
		// Grid
		this.grid.init();
	},
	button: {
		search: function () {
			listObj.grid.itp_OPER02010_search = true;
			let param = $('#ITP_FORM_OPER02010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(OPER02010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		},
		create:  function () {
			pageObj.switchScreen('ADD');
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER02010_DETAIL');
			createObj.init();
		}
	},
	grid: {
		init: function() {
			// 데이터 없을때
			this.itp_fn_OPER02010_empty.push();
			itp_fn_jqgrid_resize(OPER02010_GRID_ID, OPER02010_GRID_LIST, 'lg');
			itp_fn_fire_window_resize();
			this.search();
		},
		itp_OPER02010_param: {},
		itp_OPER02010_search: false,
		colModel: gridColModel.list,
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			var _this = this;
			let param = $('#ITP_FORM_OPER02010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			var option = {
				gridId: OPER02010_GRID_ID,
				colModel: this.colModel,
				param: JSON.stringify(param),
				url: DOMAIN + NTICE_DETAIL_GRID_LIST,
				pager: OPER02010_GRID_PAGER,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'nticeTitl') {
						const nticeNoVal = $(this).jqGrid('getCell', rowId, 'nticeNo');
						const key = {nticeNo: nticeNoVal, viewCd: 'R'};
						var param = $.param(key);
						viewObj.init(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, OPER02010_GRID_ID, true, 'number', 'OPER02010', listObj.grid.itp_OPER02010_search, _this.itp_fn_OPER02010_empty, true, data.gridRecords, true);
					var ids = $(OPER02010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(OPER02010_GRID_ID).jqGrid('setCell', rowId, 'nticeTitl', '', ITP_GRID_COL_STYLE.link);
						// $(OPER02010_GRID_ID).jqGrid('setCell', rowId, 'afflShopNm', '', ITP_GRID_COL_STYLE.link);
					});

					if ($('#ITP_CONTAINER').data('openYn') == 'Y') {
						$('#ITP_CONTAINER').data('openYn', 'N');
						const keyNew = {nticeNo: $('#ITP_CONTAINER').data('nticeNo'), viewCd: 'R'};
						var paramNew = $.param(keyNew);
						viewObj.init(paramNew);
					}
				}
			};
			itp_fn_grid_make_remote(option);
		},
		itp_fn_OPER02010_empty: {
			push: function() {
				let param = $('#ITP_FORM_OPER02010_SEARCH').serializeObject();
				listObj.grid.itp_OPER02010_param = param;
			},
			back: function() {
				var _this = listObj.grid;
				$('#ITP_FORM_OPER02010_DEVI_TP_CD').val(_this.itp_OPER02010_param.safflShopId);
				$('#ITP_FORM_OPER02010_ORDER_YN').val(_this.itp_OPER02010_param.safflShopNm);
				$('#ITP_FORM_OPER02010_ADT_AUTH_CD').val(_this.itp_OPER02010_param.sbrandId);
				$('#ITP_FORM_OPER02010_EMAIL_RCV_YN').val(_this.itp_OPER02010_param.snticeTitl);
				$('#ITP_FORM_OPER02010_FROM_DT').val(_this.itp_OPER02010_param.fromDt);
				$('#ITP_FORM_OPER02010_TO_DT').val(_this.itp_OPER02010_param.toDt);
			}
		},
		reload : function() {
			var _this = this;
			$(OPER02010_GRID_EMPTY).off('click').on('click', function() {
				_this.itp_fn_OPER02010_empty.back();
				_this.itp_OPER02010_param.gridSize = $.jgrid.defaults.rowNum;
				$(OPER02010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_OPER02010_param)}).trigger('reloadGrid');
			});
		},
		clearData : function() {
			$(OPER02010_GRID_ID).jqGrid('clearGridData', true);
			$(OPER02010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(OPER02010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(OPER02010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(OPER02010_GRID_ID);
		}
	}
};

/*상세화면 Object*/
let viewObj = {
	init: function (param) {
		this.load(param);
	},
	button: {
	},
	load: function(param) {
		fn_ajax_call(NTICE_INFO_NTICE, param, this.callback, 'GET');
	},
	callback: function (result) {
		console.log(result);
		pageObj.switchScreen('VIEW');
		$('#ITP_FORM_OPER02010_VIEW #ITP_FORM_OPER02010_VIEW_USER_ID').val(result.nticeNo);
		$('#ITP_FORM_OPER02010_VIEW .fnNticeTitl').text(result.nticeTitl);
		$('#ITP_FORM_OPER02010_VIEW .fnNotiDay').text(result.notiStDay+' ~ '+result.notiEdDay);
		$('#ITP_FORM_OPER02010_VIEW .fnDelYn').text(result.delYn);
		$('#ITP_FORM_OPER02010_VIEW .fnNticeDesc').html(result.nticeDesc.replace(/(\n|\r\n)/g, '<br>'));
		$('#ITP_FORM_OPER02010_VIEW .fnTargetNm').text(result.targetNm);
		$('#ITP_FORM_OPER02010_VIEW_FILE_NO').val(result.fileNo); //파일번호 셋팅

		//파일업로드(뷰화면)
		$('#ITP_OPER02010_VIEW_UPLOAD').empty();
		const fileArgs = {
			'fileNo': $('#ITP_FORM_OPER02010_VIEW_FILE_NO').val(),
			'viewCd': $('#ITP_FORM_OPER02010_VIEW_VIEW_CD').val()
		};
		itp_fn_set_file_upload('ITP_OPER02010_VIEW_UPLOAD', 'notice', true, false, 'OPER02010', fileArgs);

		// 권한정보 리스트 조회
		pageObj.grid.init('VIEW');
	}
};

/*수정화면 Object*/
let modifyObj = {
	init: function (param) {
	},
	button: {
		modify: function () {
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPER02010_DETAIL');
			const nticeNoVal = $('#ITP_FORM_OPER02010_VIEW_USER_ID').val();
			const key = {nticeNo: nticeNoVal, viewCd: 'R'};
			var param = $.param(key);
			modifyObj.load(param);
		}
	},
	load: function(param) {
		fn_ajax_call(NTICE_INFO_NTICE, param, this.callback, 'GET');
	},
	callback: function (result) {
		console.log(result);
		pageObj.switchScreen('MODIFY');
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_VIEW_CD').val('U');
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_NTICE_NO').val(result.nticeNo);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_NTICE_TITL').val(result.nticeTitl);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_FROM_DT').val(result.notiStDay);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_TO_DT').val(result.notiEdDay);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DEL_YN').val(result.delYn);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_NTICE_DESC').val(result.nticeDesc);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_TARGET_CD').val(result.targetCd);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_BRAND').prop('checked', result.brandChk === 'Y');
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_STORE').prop('checked', result.shopChk === 'Y');
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SPPLY').prop('checked', result.supplyChk === 'Y');
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_BRAND_CHK').val(result.brandChk);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_STORE_CHK').val(result.shopChk);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SPPLY_CHK').val(result.supplyChk);
		$('#ITP_FORM_OPER02010_DETAIL_FILE_NO').val(result.fileNo); //파일번호 셋팅

		// 가맹점 셋팅
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP_ID').val(result.afflShopId);
		$('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP_NM').val(result.afflShopNm);
		// $('#ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP').attr('disabled', true);
		// $('#ITP_FORM_OPER02010_DETAIL_DELETE_AFFL_SHOP').attr('disabled', true);
		// $('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP_NM').attr('readonly', true);
		// $('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_SEARCH_BRAND_ID').attr('readonly', true);
		if(result.brandId && result.brandId != '') {
			var brandList = [{'brandId':result.brandId, 'brandNm':result.brandNm}];
			fn_make_select_brand(brandList, 'ITP_FORM_OPER02010_DETAIL_SEARCH_BRAND_ID');
		}

		let targetIndex = $('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_TARGET_CD option').index($('#ITP_FORM_OPER02010_DETAIL #ITP_FORM_OPER02010_DETAIL_TARGET_CD option:selected'));
		// if(targetIndex > 0) {
		if(result.targetCd && result.targetCd != '') {
			$('#ITP_BTN_OPER02010_DETAIL_ADDROW').attr('disabled', false);
			$('#ITP_BTN_OPER02010_DETAIL_DELROW').attr('disabled', false);
		}

		//파일업로드(수정화면)
		$('#ITP_OPER02010_DETAIL_UPLOAD').empty();
		const fileArgs = {
			'fileNo': $('#ITP_FORM_OPER02010_DETAIL_FILE_NO').val(),
			'viewCd': $('#ITP_FORM_OPER02010_DETAIL_VIEW_CD').val(),
			'showYn': $('#ITP_OPER02010_DETAIL_UPLOAD').attr('data-show-yn'),
			'fileId': '#ITP_FORM_OPER02010_DETAIL_FILE_NO' //파일번호를 서버에서 받아서 넣을 파일번호 인풋박스 아이디
		};
		itp_fn_set_file_upload('ITP_OPER02010_DETAIL_UPLOAD', 'notice', true, false, 'OPERATION02010', fileArgs);

		// 리스트 조회
		createObj.form.init();
		pageObj.grid.init('DETAIL');
	}
};

/*신규화면 Object*/
let createObj = {
	init: function () {
		this.form.init();
		this.load();
	},
	form: {
		init: function () {
			this.selectbox();
			this.checkbox();
		},
		selectbox: function () {
			// 브랜드 selectbox 선택
			$('#ITP_FORM_OPER02010_DETAIL_BRAND_ID').off('change').on('change', function() {
				if(this.selectedIndex > 0) {
					$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD option:eq(0)').prop('selected', true);
					$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD').prop('disabled', true).trigger('change');
				} else {
					$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD').prop('disabled', false);
				}
			});
			// 공지대상 selectbox 선택
			$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD').off('change').on('change', function() {
				if(this.selectedIndex > 0) {
					$('#ITP_BTN_OPER02010_DETAIL_ADDROW').prop('disabled', false);
					$('#ITP_BTN_OPER02010_DETAIL_DELROW').prop('disabled', false);
				} else {
					$('#ITP_BTN_OPER02010_DETAIL_ADDROW').prop('disabled', true);
					$('#ITP_BTN_OPER02010_DETAIL_DELROW').prop('disabled', true);
					$(OPER02010_DETAIL_GRID_ID).jqGrid('clearGridData');
				}
			});
		},
		checkbox: function () {
			// 공지대상 checkbox 선택
			$('#ITP_FORM_OPER02010_TARGET').find('input:checkbox').off('change').on('change', function() {
				$(this).next().val($(this).is(':checked') ? 'Y' : '');
			});
		}
	},
	button: {
		addRow: function() {
			// 팝업
			var popFn = function(rowDataPop) {
				console.log(rowDataPop);
				// 기존등록 사용자ID
				var exists = '';
				const rowData = $(OPER02010_DETAIL_GRID_ID).getRowData();
				$.each(rowData, function(key, value) {
					exists = exists + value.brandId + ';';
				});

				$.each(rowDataPop, function(key, value) {
					// console.log(JSON.stringify(value));
					// console.log(exists.indexOf(value.userId));
					if(exists.indexOf(value.brandId) < 0) {
						$(OPER03010_DETAIL_GRID_ID).jqGrid('addRowData', value.brandId, value, 'last');
						var rids = $(OPER01010_DETAIL_GRID_ID).jqGrid('getDataIDs');
						var last_row_id = rids[rids.length - 1];
						$(OPER01010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'viewCd', 'C');
						// 행추가
						// $(OPER02010_DETAIL_GRID_ID).jqGrid('addRow', {position: 'last'});
						// var rids = $(OPER02010_DETAIL_GRID_ID).jqGrid('getDataIDs');
						// var last_row_id = rids[rids.length - 1];
						// $(OPER02010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'viewCd', 'C');
						// $(OPER02010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'brandId', value.brandId);
						// $(OPER02010_DETAIL_GRID_ID).jqGrid('setCell', last_row_id, 'brandNm', value.brandNm);
					}
				});
				$(OPER02010_DETAIL_GRID_EMPTY).hide();
			};
			var agrs = {'afflShopId': $('#ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP_ID').val()};
			fn_call_popup('biz', 'BIZPOP_AFFL_BRAND', '#ITP_ASIDE', popFn, agrs, 'S');
		},
		delRow: function() {
			itp_fn_grid_del_row(OPER02010_DETAIL_GRID_ID);
		},
		save: function() {
			const formId = '#ITP_FORM_OPER02010_DETAIL';
			itp_fn_form_clear_validate(null, formId);
			var vali_nticeNo = itp_fn_form_validate(formId, formId + '_NTICE_TITL', ['empty'], undefined);
			var vali_nticeDesc = itp_fn_form_validate(formId, formId + '_NTICE_DESC', ['empty'], undefined);
			var vali_targetCd = itp_fn_form_validate(formId, formId + '_TARGET_CD', ['empty'], undefined);

			if (vali_nticeNo && vali_nticeDesc && vali_targetCd) {
				let gridInsertData = [];
				let gridUpdateData = [];
				let gridDeleteData = [];
				const rowData = $(OPER02010_DETAIL_GRID_ID).getRowData();
				const keyValue = $(formId + '_USER_ID').val();
				$.each(rowData, function(key, value) {
					if (value.viewCd != 'R') {
						value.nticeNo = keyValue;
						if (value.viewCd == 'C') {
							gridInsertData.push(value);
						} else if (value.viewCd == 'U') {
							gridUpdateData.push(value);
						} else if (value.viewCd == 'D') {
							gridDeleteData.push(value);
						}
					}
				});
				$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD').attr('disabled', false);
				let param = $(formId).serializeObject();
				param.gridInsertData = gridInsertData;
				param.gridUpdateData = gridUpdateData;
				param.gridDeleteData = gridDeleteData;
				// console.log(JSON.stringify(param));

				var searhFn = function() {
					ITP_FORM_OPER02010_DETAIL_IS_WRITING = false;
					listObj.grid.search();
				};
				fn_ajax_call(NTICE_SAVE_NTICE, JSON.stringify(param), searhFn, 'POST');
			}
		},
		cancel: function() {
			listObj.grid.search();
		}
	},
	load: function () {
		//파일업로드(등록화면)
		$('#ITP_FORM_OPER02010_DETAIL_FILE_NO').val('');
		$('#ITP_OPER02010_DETAIL_UPLOAD').empty();
		const fileArgs = {
			'fileNo': $('#ITP_FORM_OPER02010_DETAIL_FILE_NO').val(),
			'viewCd': $('#ITP_FORM_OPER02010_DETAIL_VIEW_CD').val(),
			'showYn': $('#ITP_OPER02010_DETAIL_UPLOAD').attr('data-show-yn'),
			'fileId': '#ITP_FORM_OPER02010_DETAIL_FILE_NO' //파일번호를 서버에서 받아서 넣을 파일번호 인풋박스 아이디
		};
		itp_fn_set_file_upload('ITP_OPER02010_DETAIL_UPLOAD', 'notice', true, false, 'OPER02010', fileArgs);

		// 권한정보 리스트 조회
		pageObj.grid.init('DETAIL');
	}
};

/*가맹점 조회 Object*/
let afflShopObj = {
	init: function() {
		(AUTH_TYPE_CD === '10' || AUTH_TYPE_CD === '20') ? this.action() : this.make();
	},
	button: function() {
		var _this = this;
		// 가맹점 조회 버튼 클릭
		$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP_BTN').on('click', function() {
			_this.popup('L');
		});
		// 가맹점 텍스트 삭제 버튼 클릭
		$('#ITP_FORM_OPER02010_DELETE_AFFL_SHOP_BTN').on('click', function() {
			$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP_ID').val('');
			$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP_NM').val('');
			$('select#ITP_FORM_OPER02010_SEARCH_BRAND_ID option').remove();
		});
		// 신규등록 가맹점 조회 버튼 클릭
		$('#ITP_FORM_OPER02010_DETAIL_SEARCH_AFFL_SHOP').on('click', function() {
			_this.popup('C');
		});
		// 신규등록 가맹점 텍스트 삭제 버튼 클릭
		$('#ITP_FORM_OPER02010_DETAIL_DELETE_AFFL_SHOP').on('click', function() {
			$('#ITP_FORM_OPER02010_DETAIL_AFFL_SHOP_ID').val('');
			$('#ITP_FORM_OPER02010_DETAIL_AFFL_SHOP_NM').val('');
			$('select#ITP_FORM_OPER02010_DETAIL_BRAND_ID option').remove();
			$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD option:eq(0)').prop('selected', true);
			$('#ITP_FORM_OPER02010_DETAIL_TARGET_CD').trigger('change');
		});
	},
	make: function() {
		$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP').hide();
		$('#ITP_FORM_OPER02010_DELETE_AFFL_SHOP').hide();
		if(AFFL_SHOP_LIST) {
			$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP_ID').val(AFFL_SHOP_LIST[0].afflShopId);
			$('#ITP_FORM_OPER02010_SEARCH_AFFL_SHOP_NM').val(AFFL_SHOP_LIST[0].afflShopNm);
		}
		if(AFFL_BRAND_LIST) {
			fn_make_select_brand(AFFL_BRAND_LIST, 'ITP_FORM_OPER02010_SEARCH_BRAND_ID');
		}
	},
	action: function() {
		this.button();
	},
	popup: function (view) {
		// 팝업
		var popFn = function(rowDataPop) {
			console.log(rowDataPop);
			var id = (view === 'C') ? 'ITP_FORM_OPER02010_DETAIL' : 'ITP_FORM_OPER02010_SEARCH';
			console.log(id);
			if(rowDataPop.AFFL_SHOP) {
				$('#'+ id + '_AFFL_SHOP_ID').val(rowDataPop.AFFL_SHOP.afflShopId);
				$('#'+ id + '_AFFL_SHOP_NM').val(rowDataPop.AFFL_SHOP.afflShopNm);
			}
			if(rowDataPop.AFFL_BRAND) {
				fn_make_select_brand(rowDataPop.AFFL_BRAND, id + '_BRAND_ID', true, '선택');
			}
		};
		fn_call_popup('biz', 'BIZPOP_AFFL_SHOP', '#ITP_ASIDE', popFn, null, 'S');
	}
};
